﻿Imports Microsoft.VisualBasic
Imports System.Xml
Imports System.IO

''' <summary>
''' editionmanager provides the funtions that are necessary to display, alter and change data with a Webdatagrid
''' </summary>
Public Class editionmanager
   Inherits System.Web.UI.Page
   Private baseUri As Uri
   Private fulluri As Uri
   Private strCompletePath As String
   Private objEdition As edition
   Private reader As XmlReader
   Private writer As XmlWriter
   Private resolver As XmlUrlResolver
   Private rStream As Stream
   Private strFullPath As String
   Private strFilename As String
   Private xmlDoc As XmlDocument

   Public Sub New()
      Dim flgError As Boolean
      flgError = False
      'get the filename from a session var

      strFullPath = Session("strDataPath")
      strFilename = Session("strFile")

      If strFilename Is Nothing Then
         Exit Sub
      End If

      xmlDoc = Nothing

      'Point the resolver at the desired resource and resolve as a stream.
      baseUri = New Uri(strFullPath)

      strCompletePath = strFullPath & strFilename

      'Create an XmlUrlResolver with default credentials.
      resolver = New XmlUrlResolver()
      resolver.Credentials = System.Net.CredentialCache.DefaultCredentials

      ' Create the reader with the resolved stream and display the data.
      fulluri = resolver.ResolveUri(baseUri, strFilename)
      Try
         rStream = DirectCast(resolver.GetEntity(fulluri, Nothing, GetType(Stream)), Stream)
      Catch ex As Exception
         flgError = True
      End Try

      If Not flgError Then
         xmlDoc = New XmlDocument()
         reader = XmlReader.Create(rStream)
         Try
            xmlDoc.Load(reader)
            reader.Close()
            rStream.Close()
         Catch ex As Exception
            'we do not throw an exception at this point. The file was checked before
            'so give only an empty obj.
            xmlDoc = Nothing
         End Try
      End If
   End Sub

   Public Sub deleteEdition(ByVal Code As String)
      'do not really delete rows, but set the amount to zero

      Dim theNode As XmlNode
      Dim root As XmlNode
      Dim strTmp As String

      root = xmlDoc.DocumentElement
      theNode = Nothing
      'theAttribute = Nothing
      'Searching the note using the XPATH is not working correctly. Don't know why
      'so we do a "manual" search
      If (root.HasChildNodes) Then
         For Each child In root.ChildNodes
            strTmp = child.GetAttribute("editionCode")
            If (strTmp = Code) Then
               theNode = child
               Exit For
            End If
         Next
      End If

      ''Delete the node : at this time deletion is prohibited at this time. There is a javascript button "inactvate" an this will set all amounts to 0 
      'So at this point we do nothing
   End Sub

   'Get one edition identified by the key
   Public Function getEdition(ByVal Code As String) As edition
      Dim element As XmlElement = Nothing
      Dim strTmp As String = Nothing
      Dim subelement As XmlElement = Nothing
      Dim i As Integer

      'may be there is no record found
      objEdition = Nothing

      If Not IsNothing(xmlDoc) Then
         For Each element In xmlDoc.DocumentElement
            strTmp = element.GetAttribute("editionCode")

            If strTmp.Equals(Code) Then
               objEdition = New edition
               objEdition.Name = element.GetAttribute("editionDescription")
               objEdition.Baseversion = element.GetAttribute("baseVersion")
               objEdition.Basename = element.GetAttribute("baseName")
               'now only one Imrpint Flag from now on; for that we use the ImprintFront part 
               strTmp = element.GetAttribute("imprint")
               If (strTmp = "1") Then
                  objEdition.ImprintFront = "ja"
               Else
                  objEdition.ImprintFront = "nein"
               End If
               'objEdition.ImprintFront = element.GetAttribute("ImprintFront")
               'objEdition.ImprintBack = element.GetAttribute("ImprintBack")
               objEdition.Components = element.GetAttribute("components")
               objEdition.Code = element.GetAttribute("editionCode")
               'preset all ShipIds and Amounts initially
               objEdition.ShipId1 = ""
               objEdition.Amount1 = "0"
               objEdition.ShipId2 = ""
               objEdition.Amount2 = "0"
               objEdition.ShipId3 = ""
               objEdition.Amount3 = "0"
               objEdition.ShipId4 = ""
               objEdition.Amount4 = "0"
               objEdition.ShipId5 = ""
               'objEdition.Amount6 = "0"
               'objEdition.ShipId6 = ""
               'objEdition.Amount6 = "0"
               If element.HasChildNodes Then
                  For i = 0 To element.ChildNodes.Count - 1
                     subelement = element.ChildNodes(i)
                     strTmp = subelement.GetAttribute("deliveryDescription")
                     Select Case strTmp
                        Case "Edition1"
                           objEdition.ShipId1 = subelement.GetAttribute("deliveryAddressId")
                           objEdition.Amount1 = subelement.GetAttribute("quantity")
                           objEdition.DelDateTime1 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                        Case "Edition2"
                           objEdition.ShipId2 = subelement.GetAttribute("deliveryAddressId")
                           objEdition.Amount2 = subelement.GetAttribute("quantity")
                           objEdition.DelDateTime2 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                        Case "Edition3"
                           objEdition.ShipId3 = subelement.GetAttribute("deliveryAddressId")
                           objEdition.Amount3 = subelement.GetAttribute("quantity")
                           objEdition.DelDateTime3 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                        Case "Edition4"
                           objEdition.ShipId4 = subelement.GetAttribute("deliveryAddressId")
                           objEdition.Amount4 = subelement.GetAttribute("quantity")
                           objEdition.DelDateTime4 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                        Case "HomeEdition"
                           objEdition.ShipId5 = subelement.GetAttribute("deliveryAddressId")
                           objEdition.Amount5 = subelement.GetAttribute("quantity")
                           objEdition.DelDateTime5 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                           'Case "SampleEdition"
                           '   objEdition.ShipId6 = subelement.GetAttribute("deliveryAddressId")
                           '   objEdition.Amount6 = subelement.GetAttribute("quantity")
                     End Select
                  Next (i)
               End If
               Exit For
            End If
         Next
      End If

      Return objEdition
   End Function

   'get all the editions into an collection
   Public Function getEditions() As editionsCollection
      Dim element As XmlElement = Nothing
      Dim subelement As XmlElement = Nothing
      Dim lstEd As New editionsCollection()
      Dim i As Integer
      Dim strTmp As String


      If Not IsNothing(xmlDoc) Then
         For Each element In xmlDoc.DocumentElement
            objEdition = New edition
            objEdition.Name = element.GetAttribute("editionDescription")
            objEdition.Baseversion = element.GetAttribute("baseVersion")
            objEdition.Basename = element.GetAttribute("baseName")
            'now only one Imrpint Flag from now on; for that we use the ImprintFront part 
            strTmp = element.GetAttribute("imprint")
            If (strTmp = "1") Then
               objEdition.ImprintFront = "ja"
            Else
               objEdition.ImprintFront = "nein"
            End If
            'objEdition.ImprintFront = element.GetAttribute("ImprintFront")
            'objEdition.ImprintBack = element.GetAttribute("ImprintBack")
            objEdition.Components = element.GetAttribute("components")
            objEdition.Code = element.GetAttribute("editionCode")
            'preset all ShipIds and Amounts initially
            objEdition.ShipId1 = ""
            objEdition.Amount1 = "0"
            objEdition.ShipId2 = ""
            objEdition.Amount2 = "0"
            objEdition.ShipId3 = ""
            objEdition.Amount3 = "0"
            objEdition.ShipId4 = ""
            objEdition.Amount4 = "0"
            objEdition.ShipId5 = ""
            'objEdition.Amount6 = "0"
            'objEdition.ShipId6 = ""
            'objEdition.Amount6 = "0"
            If element.HasChildNodes Then
               For i = 0 To element.ChildNodes.Count - 1
                  subelement = element.ChildNodes(i)
                  strTmp = subelement.GetAttribute("deliveryDescription")
                  Select Case strTmp
                     Case "Edition1"
                        objEdition.ShipId1 = subelement.GetAttribute("deliveryAddressId")
                        objEdition.Amount1 = subelement.GetAttribute("quantity")
                        objEdition.DelDateTime1 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                     Case "Edition2"
                        objEdition.ShipId2 = subelement.GetAttribute("deliveryAddressId")
                        objEdition.Amount2 = subelement.GetAttribute("quantity")
                        objEdition.DelDateTime2 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                     Case "Edition3"
                        objEdition.ShipId3 = subelement.GetAttribute("deliveryAddressId")
                        objEdition.Amount3 = subelement.GetAttribute("quantity")
                        objEdition.DelDateTime3 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                     Case "Edition4"
                        objEdition.ShipId4 = subelement.GetAttribute("deliveryAddressId")
                        objEdition.Amount4 = subelement.GetAttribute("quantity")
                        objEdition.DelDateTime4 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                     Case "HomeEdition"
                        objEdition.ShipId5 = subelement.GetAttribute("deliveryAddressId")
                        objEdition.Amount5 = subelement.GetAttribute("quantity")
                        objEdition.DelDateTime5 = UTCToString(subelement.GetAttribute("deliveryDateTime"))
                        'Case "SampleEdition"
                        '   objEdition.ShipId6 = subelement.GetAttribute("deliveryAddressId")
                        '   objEdition.Amount6 = subelement.GetAttribute("quantity")
                  End Select
               Next (i)
            End If
            lstEd.Add(objEdition)
         Next
      End If
      Return lstEd
   End Function

   Public Sub insertEdition(ByVal Code As String, ByVal Name As String, ByVal Basename As String, ByVal ImprintFront As String, ByVal Components As String, ByVal ShipId1 As String, ByVal Amount1 As String, _
                            ByVal ShipId2 As String, ByVal Amount2 As String, ByVal ShipId3 As String, ByVal Amount3 As String, ByVal ShipId4 As String, ByVal Amount4 As String, ByVal ShipId5 As String, ByVal Amount5 As String, _
                            ByVal DelDateTime1 As String, ByVal DelDateTime2 As String, ByVal DelDateTime3 As String, ByVal DelDateTime4 As String, ByVal DelDateTime5 As String)

      Dim answers As String
      Dim arrAnswers As String()
      Dim elem As XmlElement
      Dim flgNew As Boolean
      Dim i As Integer
      Dim myBaseMgr As basenameManager
      Dim myShipAddress As shipAddress
      Dim myshipManager As shipAddressManager
      Dim root As XmlNode
      Dim theNode As XmlNode
      Dim subelement As XmlElement
      Dim strTmp As String


      flgNew = False

      If IsNothing(xmlDoc) Then
         xmlDoc = New XmlDocument
         flgNew = True
      End If

      'There are field validators, but they are still checked
      'If (Name Is Nothing) Or (Basename Is Nothing) Or (ImprintFront Is Nothing) Or (ImprintBack Is Nothing) Or (Components Is Nothing) Or (Code Is Nothing) Then
      If (Name Is Nothing) Or (Basename Is Nothing) Or (ImprintFront Is Nothing) Or (Components Is Nothing) Or (Code Is Nothing) Then
         Exit Sub
      End If

      root = xmlDoc.DocumentElement

      'check if a note with the given key exists, if yes then exit
      theNode = root.SelectSingleNode("descendant::edition[attribute::editionCode='" & Code & "']")
      'Delete the old node 
      If Not theNode Is Nothing Then
         Exit Sub
      End If
      'create an instance of shipManager
      myshipManager = New shipAddressManager

      'if a user selects a basename the values of ImprintFront and ImprintBack should be set correctly
      'because they are fixed with exception of basename "standard", normally the correct values should be set by the grid, but sometimes this does not work correctly
      'do not "translate 'ja' or 'nein' at this point
      If (Basename.ToLower() <> "standard") Then
         myBaseMgr = New basenameManager
         answers = myBaseMgr.getImprintValues(Basename)
         arrAnswers = answers.Split(":")
         'ImprintBack = arrAnswers(0)
         ImprintFront = arrAnswers(1)
         'Else
         '   'there are 2 Lines with basename "standard", but both have a "no" for ImprintBack
         '   myBaseMgr = New basenameManager
         '   answers = myBaseMgr.getImprintValues(Basename)
         '   arrAnswers = answers.Split(":")
         '   ImprintBack = arrAnswers(0)
      End If

      elem = xmlDoc.CreateElement("retailedition")
      elem.SetAttribute("editionCode", Code)
      elem.SetAttribute("editionDescription", Name)
      Select Case Basename
         Case "Fisch"
            elem.SetAttribute("baseVersion", "2")
         Case "Saison"
            elem.SetAttribute("baseVersion", "3")
         Case "halbeSeite"
            elem.SetAttribute("baseVersion", "4")
         Case "ganze Seite"
            elem.SetAttribute("baseVersion", "5")
         Case "Aktionsseite"
            elem.SetAttribute("baseVersion", "6")
         Case "Aktionseite plus Fisch"
            elem.SetAttribute("baseVersion", "7")
         Case "Aktionseite plus Gertänke"
            elem.SetAttribute("baseVersion", "8")
         Case Else
            elem.SetAttribute("baseVersion", "1")
      End Select
      elem.SetAttribute("baseName", Basename)
      'only one Imprint Flag now and that has to be 0 or 1
      'elem.SetAttribute("ImprintFront", ImprintFront)
      'elem.SetAttribute("ImprintBack", ImprintBack)
      If (ImprintFront = "ja") Then
         elem.SetAttribute("imprint", "1")
      Else
         elem.SetAttribute("imprint", "0")
      End If
      If (TryToParse(Components)) Then
         elem.SetAttribute("components", Components)
      Else
         elem.SetAttribute("components", "0")
      End If

      'Now for every shipping address and every amount one subnode has to be created
      For i = 1 To 5
         subelement = xmlDoc.CreateElement("shippingAddress")
         Select Case i
            Case 1 'Auflage1
               subelement.SetAttribute("deliveryDescription", "Edition1")
               If (TryToParse(Amount1)) Then
                  subelement.SetAttribute("quantity", Amount1)
               Else
                  subelement.SetAttribute("quantity", 0)
               End If
               If (ShipId1 = "") Or (ShipId1 Is Nothing) Then
                  ShipId1 = ""
                  subelement.SetAttribute("deliveryAddressId", 0)
               Else
                  subelement.SetAttribute("deliveryAddressId", ShipId1)
               End If
               If Not ShipId1 = "" Then
                  myShipAddress = myshipManager.getShipAdress(ShipId1)
                  If Not myShipAddress Is Nothing Then
                     strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                  Else
                     strTmp = "0"
                  End If
               Else
                  strTmp = "0"
               End If
               If (strTmp = "0") Then 'Alle anderen
                  subelement.SetAttribute("mainUnit", "1810")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "12")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "12")
                  subelement.SetAttribute("packingMethod", "BUN1")
               Else 'Fruchthofadresse
                  subelement.SetAttribute("mainUnit", "1821")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "7")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "7")
                  subelement.SetAttribute("packingMethod", "BUN1")
               End If
               subelement.SetAttribute("condition", "CPT")
               subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime1))
            Case 2 'Auflage2
               subelement.SetAttribute("deliveryDescription", "Edition2")
               If (TryToParse(Amount2)) Then
                  subelement.SetAttribute("quantity", Amount2)
               Else
                  subelement.SetAttribute("quantity", 0)
               End If
               If (ShipId2 = "") Or (ShipId2 Is Nothing) Then
                  ShipId2 = ""
                  subelement.SetAttribute("deliveryAddressId", 0)
               Else
                  subelement.SetAttribute("deliveryAddressId", ShipId2)
               End If
               If Not ShipId2 = "" Then
                  myShipAddress = myshipManager.getShipAdress(ShipId2)
                  If Not myShipAddress Is Nothing Then
                     strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                  Else
                     strTmp = "0"
                  End If
               Else
                  strTmp = "0"
               End If
               If (strTmp = "0") Then 'Alle anderen
                  subelement.SetAttribute("mainUnit", "1810")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "12")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "12")
                  subelement.SetAttribute("packingMethod", "BUN1")
               Else 'Fruchthofadresse
                  subelement.SetAttribute("mainUnit", "1821")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "7")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "7")
                  subelement.SetAttribute("packingMethod", "BUN1")
               End If
               subelement.SetAttribute("condition", "CPT")
               subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime2))
            Case 3 'Auflage3
               subelement.SetAttribute("deliveryDescription", "Edition3")
               If (TryToParse(Amount3)) Then
                  subelement.SetAttribute("quantity", Amount3)
               Else
                  subelement.SetAttribute("quantity", 0)
               End If
               If (ShipId3 = "") Or (ShipId3 Is Nothing) Then
                  ShipId3 = ""
                  subelement.SetAttribute("deliveryAddressId", 0)
               Else
                  subelement.SetAttribute("deliveryAddressId", ShipId3)
               End If
               If Not ShipId3 = "" Then
                  myShipAddress = myshipManager.getShipAdress(ShipId3)
                  If Not myShipAddress Is Nothing Then
                     strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                  Else
                     strTmp = "0"
                  End If
               Else
                  strTmp = "0"
               End If
               If (strTmp = "0") Then 'Alle anderen
                  subelement.SetAttribute("mainUnit", "1810")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "12")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "12")
                  subelement.SetAttribute("packingMethod", "BUN1")
               Else 'Fruchthofadresse
                  subelement.SetAttribute("mainUnit", "1821")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "7")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "7")
                  subelement.SetAttribute("packingMethod", "BUN1")
               End If
               subelement.SetAttribute("condition", "CPT")
               subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime3))
            Case 4 'Auflage4
               subelement.SetAttribute("deliveryDescription", "Edition4")
               If (TryToParse(Amount4)) Then
                  subelement.SetAttribute("quantity", Amount4)
               Else
                  subelement.SetAttribute("quantity", 0)
               End If
               If (ShipId4 = "") Or (ShipId4 Is Nothing) Then
                  ShipId4 = ""
                  subelement.SetAttribute("deliveryAddressId", 0)
               Else
                  subelement.SetAttribute("deliveryAddressId", ShipId4)
               End If
               If Not ShipId4 = "" Then
                  myShipAddress = myshipManager.getShipAdress(ShipId4)
                  If Not myShipAddress Is Nothing Then
                     strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                  Else
                     strTmp = "0"
                  End If
               Else
                  strTmp = "0"
               End If
               If (strTmp = "0") Then 'Alle anderen
                  subelement.SetAttribute("mainUnit", "1810")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "12")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "12")
                  subelement.SetAttribute("packingMethod", "BUN1")
               Else 'Fruchthofadresse
                  subelement.SetAttribute("mainUnit", "1821")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "7")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "7")
                  subelement.SetAttribute("packingMethod", "BUN1")
               End If
               subelement.SetAttribute("condition", "CPT")
               subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime4))
            Case 5 'Hausauflage
               subelement.SetAttribute("deliveryDescription", "HomeEdition")
               If (TryToParse(Amount5)) Then
                  subelement.SetAttribute("quantity", Amount5)
               Else
                  subelement.SetAttribute("quantity", 0)
               End If
               If (ShipId5 = "") Or (ShipId5 Is Nothing) Then
                  ShipId5 = ""
                  subelement.SetAttribute("deliveryAddressId", 0)
               Else
                  subelement.SetAttribute("deliveryAddressId", ShipId5)
               End If
               If Not ShipId5 = "" Then
                  myShipAddress = myshipManager.getShipAdress(ShipId5)
                  If Not myShipAddress Is Nothing Then
                     strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                  Else
                     strTmp = "0"
                  End If
               Else
                  strTmp = "0"
               End If
               If (strTmp = "0") Then 'Hausauflage
                  subelement.SetAttribute("mainUnit", "1823")
                  subelement.SetAttribute("subUnit", "1826")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "7")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "7")
                  subelement.SetAttribute("packingMethod", "BUN2")
               Else 'Fruchthofadresse
                  subelement.SetAttribute("mainUnit", "1821")
                  subelement.SetAttribute("subUnit", "1825")
                  subelement.SetAttribute("piecesPerSubUnit", "250")
                  subelement.SetAttribute("subPerLayer", "7")
                  subelement.SetAttribute("layerPerMain", "6")
                  subelement.SetAttribute("stacking", "7")
                  subelement.SetAttribute("packingMethod", "BUN1")
               End If
               subelement.SetAttribute("condition", "CPT")
               subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime5))
         End Select
         elem.AppendChild(subelement)
      Next

      'Add the node to the document.
      root.AppendChild(elem)
      xmlDoc.Save(strCompletePath)
   End Sub

   'Public Sub updateEdition(ByVal Code As String, ByVal Name As String, ByVal Basename As String, ByVal ImprintFront As String, ByVal ImprintBack As String, ByVal Components As String, ByVal ShipId1 As String, ByVal Amount1 As String, _
   '                         ByVal ShipId2 As String, ByVal Amount2 As String, ByVal ShipId3 As String, ByVal Amount3 As String, ByVal ShipId4 As String, ByVal Amount4 As String, ByVal ShipId5 As String, ByVal Amount5 As String)
   Public Sub updateEdition(ByVal Code As String, ByVal Name As String, ByVal Basename As String, ByVal ImprintFront As String, ByVal Components As String, ByVal ShipId1 As String, ByVal Amount1 As String, _
                            ByVal ShipId2 As String, ByVal Amount2 As String, ByVal ShipId3 As String, ByVal Amount3 As String, ByVal ShipId4 As String, ByVal Amount4 As String, ByVal ShipId5 As String, ByVal Amount5 As String, _
                            ByVal DelDateTime1 As String, ByVal DelDateTime2 As String, ByVal DelDateTime3 As String, ByVal DelDateTime4 As String, ByVal DelDateTime5 As String)
      Dim theNode As XmlNode
      Dim theAttribute As XmlNode
      Dim root As XmlNode
      Dim subelement As XmlElement
      Dim strTmp As String
      Dim i As Integer
      Dim myshipManager As shipAddressManager
      Dim myShipAddress As shipAddress


      theNode = Nothing
      root = xmlDoc.DocumentElement
      'There are field validators, but they are still checked
      'If (Name Is Nothing) Or (Basename Is Nothing) Or (ImprintFront Is Nothing) Or (ImprintBack Is Nothing) Or (Components Is Nothing) Or (Code Is Nothing) Then
      If (Name Is Nothing) Or (Basename Is Nothing) Or (ImprintFront Is Nothing) Or (Components Is Nothing) Or (Code Is Nothing) Then
         Exit Sub
      End If

      'create an instance of shipManager
      myshipManager = New shipAddressManager
      'find the note with the given key
      theNode = root.SelectSingleNode("descendant::edition[attribute::Code='" & Code & "']")
      'Searching the note using the XPATH is not working correctly. Don't know why
      'so we do a "manual" search
      If (root.HasChildNodes) Then
         For Each child In root.ChildNodes
            strTmp = child.GetAttribute("editionCode")
            If (strTmp = Code) Then
               theNode = child
               Exit For
            End If
         Next
      End If

      If Not theNode Is Nothing Then
         'get the Attribute
         theAttribute = theNode.Attributes.GetNamedItem("editionDescription")
         'set the new value
         theAttribute.Value = Name
         'write that Attribute
         theNode.Attributes.SetNamedItem(theAttribute)

         theAttribute = theNode.Attributes.GetNamedItem("baseVersion")
         Select Case Basename
            Case "Fisch"
               theAttribute.Value = "2"
            Case "Saison"
               theAttribute.Value = "3"
            Case "halbeSeite"
               theAttribute.Value = "4"
            Case "ganze Seite"
               theAttribute.Value = "5"
            Case "Aktionsseite"
               theAttribute.Value = "6"
            Case "Aktionseite plus Fisch"
               theAttribute.Value = "7"
            Case "Aktionseite plus Gertänke"
               theAttribute.Value = "8"
            Case Else
               theAttribute.Value = "1"
         End Select

         theNode.Attributes.SetNamedItem(theAttribute)

         theAttribute = theNode.Attributes.GetNamedItem("baseName")
         theAttribute.Value = Basename
         theNode.Attributes.SetNamedItem(theAttribute)

         'theAttribute = theNode.Attributes.GetNamedItem("ImprintFront")
         'theAttribute.Value = ImprintFront
         'theNode.Attributes.SetNamedItem(theAttribute)

         'theAttribute = theNode.Attributes.GetNamedItem("ImprintBack")
         'theAttribute.Value = ImprintBack
         'theNode.Attributes.SetNamedItem(theAttribute)
         theAttribute = theNode.Attributes.GetNamedItem("imprint")
         If (ImprintFront = "ja") Then
            theAttribute.Value = "1"
         Else
            theAttribute.Value = "0"
         End If
         theNode.Attributes.SetNamedItem(theAttribute)

         theAttribute = theNode.Attributes.GetNamedItem("components")
         If (TryToParse(Components)) Then
            theAttribute.Value = Components
         Else
            theAttribute.Value = "0"
         End If
         If theNode.HasChildNodes Then
            For i = (theNode.ChildNodes.Count - 1) To 0 Step -1
               subelement = theNode.ChildNodes(i)
               theNode.RemoveChild(subelement)
            Next (i)
         End If

         'Now for every shipping address and every amount one subnode has to be created
         For i = 1 To 5
            subelement = xmlDoc.CreateElement("shippingAddress")
            Select Case i
               Case 1 'Auflage1
                  subelement.SetAttribute("deliveryDescription", "Edition1")
                  If (TryToParse(Amount1)) Then
                     subelement.SetAttribute("quantity", Amount1)
                  Else
                     subelement.SetAttribute("quantity", 0)
                  End If
                  subelement.SetAttribute("deliveryAddressId", ShipId1)
                  If Not ShipId1 = "" Then
                     myShipAddress = myshipManager.getShipAdress(ShipId1)
                     If Not myShipAddress Is Nothing Then
                        strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                     Else
                        strTmp = "0"
                     End If
                  Else
                     strTmp = "0"
                  End If
                  If (strTmp = "0") Then 'Alle anderen
                     subelement.SetAttribute("mainUnit", "1810")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "12")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "12")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  Else 'Fruchthofadresse
                     subelement.SetAttribute("mainUnit", "1821")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "7")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "7")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  End If
                  subelement.SetAttribute("condition", "CPT")
                  subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime1))
               Case 2 'Auflage2
                  subelement.SetAttribute("deliveryDescription", "Edition2")
                  If (TryToParse(Amount2)) Then
                     subelement.SetAttribute("quantity", Amount2)
                  Else
                     subelement.SetAttribute("quantity", 0)
                  End If
                  subelement.SetAttribute("deliveryAddressId", ShipId2)
                  If Not ShipId2 = "" Then
                     myShipAddress = myshipManager.getShipAdress(ShipId2)
                     If Not myShipAddress Is Nothing Then
                        strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                     Else
                        strTmp = "0"
                     End If
                  Else
                     strTmp = "0"
                  End If
                  If (strTmp = "0") Then 'Alle anderen
                     subelement.SetAttribute("mainUnit", "1810")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "12")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "12")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  Else 'Fruchthofadresse
                     subelement.SetAttribute("mainUnit", "1821")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "7")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "7")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  End If
                  subelement.SetAttribute("condition", "CPT")
                  subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime2))
               Case 3 'Auflage3
                  subelement.SetAttribute("deliveryDescription", "Edition3")
                  If (TryToParse(Amount3)) Then
                     subelement.SetAttribute("quantity", Amount3)
                  Else
                     subelement.SetAttribute("quantity", 0)
                  End If
                  subelement.SetAttribute("deliveryAddressId", ShipId3)
                  If Not ShipId3 = "" Then
                     myShipAddress = myshipManager.getShipAdress(ShipId3)
                     If Not myShipAddress Is Nothing Then
                        strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                     Else
                        strTmp = "0"
                     End If
                  Else
                     strTmp = "0"
                  End If
                  If (strTmp = "0") Then 'Alle anderen
                     subelement.SetAttribute("mainUnit", "1810")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "12")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "12")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  Else 'Fruchthofadresse
                     subelement.SetAttribute("mainUnit", "1821")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "7")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "7")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  End If
                  subelement.SetAttribute("condition", "CPT")
                  subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime3))
               Case 4 'Auflage4
                  subelement.SetAttribute("deliveryDescription", "Edition4")
                  If (TryToParse(Amount4)) Then
                     subelement.SetAttribute("quantity", Amount4)
                  Else
                     subelement.SetAttribute("quantity", 0)
                  End If
                  subelement.SetAttribute("deliveryAddressId", ShipId4)
                  If Not ShipId4 = "" Then
                     myShipAddress = myshipManager.getShipAdress(ShipId4)
                     If Not myShipAddress Is Nothing Then
                        strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                     Else
                        strTmp = "0"
                     End If
                  Else
                     strTmp = "0"
                  End If
                  If (strTmp = "0") Then 'Alle anderen
                     subelement.SetAttribute("mainUnit", "1810")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "12")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "12")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  Else 'Fruchthofadresse
                     subelement.SetAttribute("mainUnit", "1821")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "7")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "7")
                     subelement.SetAttribute("packingMethod", "BUN1")
                  End If
                  subelement.SetAttribute("condition", "CPT")
                  subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime4))
               Case 5 'Hausauflage
                  subelement.SetAttribute("deliveryDescription", "HomeEdition")
                  If (TryToParse(Amount5)) Then
                     subelement.SetAttribute("quantity", Amount5)
                  Else
                     subelement.SetAttribute("quantity", 0)
                  End If
                  subelement.SetAttribute("deliveryAddressId", ShipId5)
                  If Not ShipId4 = "" Then
                     myShipAddress = myshipManager.getShipAdress(ShipId5)
                     If Not myShipAddress Is Nothing Then
                        strTmp = myShipAddress.shaType 'if strTmp = 1 -> Fruchthof
                     Else
                        strTmp = "0"
                     End If
                  Else
                     strTmp = "0"
                  End If
                  If (strTmp = "0") Then 'Hausauflage
                     subelement.SetAttribute("mainUnit", "1823")
                     subelement.SetAttribute("subUnit", "1826")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "7")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "7")
                     subelement.SetAttribute("packingMethod", "BUN2")
                     subelement.SetAttribute("condition", "CPT")
                  Else 'Fruchthofadresse
                     subelement.SetAttribute("mainUnit", "1821")
                     subelement.SetAttribute("subUnit", "1825")
                     subelement.SetAttribute("piecesPerSubUnit", "250")
                     subelement.SetAttribute("subPerLayer", "7")
                     subelement.SetAttribute("layerPerMain", "6")
                     subelement.SetAttribute("stacking", "7")
                     subelement.SetAttribute("packingMethod", "BUN1")
                     subelement.SetAttribute("condition", "CPT")
                     subelement.SetAttribute("deliveryDateTime", StringToUTC(DelDateTime5))
                  End If
            End Select
            theNode.AppendChild(subelement)
         Next
         xmlDoc.Save(strCompletePath)
      End If
   End Sub

   Private Function TryToParse(ByVal value As String) As Boolean
      Dim number As Integer
      Dim result As Boolean
      result = True
      Try
         result = Int32.TryParse(value, number)
      Catch ex As Exception
         result = False
      End Try
      Return result
   End Function

   Private Function UTCToString(ByVal UtCString As String) As String
      Dim strDD As String
      Dim strMM As String
      Dim strYYYY As String
      Dim strReturn As String

      If (UtCString.Length >= 10) Then
         strDD = UtCString.Substring(8, 2)
         strMM = UtCString.Substring(5, 2)
         strYYYY = UtCString.Substring(0, 4)
      Else
         strDD = "00"
         strMM = "00"
         strYYYY = "0000"
      End If

      strReturn = strDD + "." + strMM + "." + strYYYY

      Return strReturn

   End Function

   Private Function StringToUTC(ByVal strDate As String) As String
      Dim strDD As String
      Dim strMM As String
      Dim strYYYY As String
      Dim strTime As String
      Dim strReturn As String

      If (strDate.Length = 10) Then
         strDD = strDate.Substring(0, 2)
         strMM = strDate.Substring(3, 2)
         strYYYY = strDate.Substring(6, 4)
         strTime = "T12:00+02:00"
      Else
         strDD = "00"
         strMM = "00"
         strYYYY = "0000"
         strTime = "T12:00+02:00"
      End If

      strReturn = strYYYY + "-" + strMM + "-" + strDD + strTime

      Return strReturn
   End Function

End Class
