﻿Imports Microsoft.VisualBasic
Imports System.Xml
Imports System.IO

''' <summary>
''' shipAddressManager provides the funtions that are necessary to read the shipAddresses into a collection to display them in a dropDown
''' only read functions are provided for that xml file, no create, write or update
''' </summary>

Public Class shipAddressManager
   Inherits System.Web.UI.Page
   Private baseUri As Uri
   Private fulluri As Uri
   Private strCompletePath As String
   Private objShipAddess As shipAddress
   Private reader As XmlReader
   Private writer As XmlWriter
   Private resolver As XmlUrlResolver
   Private rStream As Stream
   Private strFullPath As String
   Private strFilename As String
   Private xmlDoc As XmlDocument

   Public Sub New()
      Dim flgError As Boolean
      flgError = False
      'get the path from a session var
      strFullPath = Session("strDataPath")
      'filname is fixed
      strFilename = "shippingAdresses.xml"

      If strFilename Is Nothing Or strFullPath Is Nothing Then
         Exit Sub
      End If

      xmlDoc = Nothing

      'Point the resolver at the desired resource and resolve as a stream.
      baseUri = New Uri(strFullPath)

      strCompletePath = strFullPath & strFilename

      'Create an XmlUrlResolver with default credentials.
      resolver = New XmlUrlResolver()
      resolver.Credentials = System.Net.CredentialCache.DefaultCredentials

      'Create the reader with the resolved stream and display the data.
      fulluri = resolver.ResolveUri(baseUri, strFilename)
      Try
         rStream = DirectCast(resolver.GetEntity(fulluri, Nothing, GetType(Stream)), Stream)
      Catch ex As Exception
         flgError = True
      End Try

      If Not flgError Then
         xmlDoc = New XmlDocument()
         reader = XmlReader.Create(rStream)
         Try
            xmlDoc.Load(reader)
            reader.Close()
            rStream.Close()
         Catch ex As Exception
            'we do not throw an exception at this point. The file was checked before
            'so give only an empty obj.
            xmlDoc = Nothing
         End Try
      End If

   End Sub

   'get one the edition with specified Id
   Public Function getShipAdress(ByVal strId As String) As shipAddress
      Dim element As XmlElement = Nothing
      Dim subelement As XmlElement = Nothing
      Dim strTmp As String

      'may be there is no record found
      objShipAddess = Nothing

      If Not IsNothing(xmlDoc) Then
         For Each element In xmlDoc.DocumentElement
            strTmp = element.GetAttribute("id")

            If strTmp.Equals(strId) Then
               objShipAddess = New shipAddress
               objShipAddess.shaId = element.GetAttribute("id")
               objShipAddess.shaName = element.GetAttribute("name")
               objShipAddess.shaType = element.GetAttribute("type")
               Exit For
            End If
         Next
      End If
      Return objShipAddess
   End Function

   'get all the editions into an collection
   Public Function getAllShipAdresses() As ShipAddessCollection
      Dim element As XmlElement = Nothing
      Dim subelement As XmlElement = Nothing
      Dim lstAdr As New ShipAddessCollection()

      If Not IsNothing(xmlDoc) Then
         For Each element In xmlDoc.DocumentElement
            objShipAddess = New shipAddress
            objShipAddess.shaId = element.GetAttribute("id")
            objShipAddess.shaName = element.GetAttribute("name")
            objShipAddess.shaType = element.GetAttribute("type")
            lstAdr.Add(objShipAddess)
         Next
      End If
      Return lstAdr
   End Function

End Class

