﻿Imports Microsoft.VisualBasic
Imports System.IO
Imports System.Xml
Imports System.Data.SqlClient
Imports System.Globalization

Partial Class _Default
   Inherits System.Web.UI.Page

   Private strAppPath As String
   Private strFullpath As String
   Private strFileName As String
   Private intThisWeek As Integer
   Private intThisYear As Integer
   Private intFileWeek As Integer

   Protected Sub btnImport_Click(ByVal sender As Object, ByVal e As Infragistics.WebUI.WebDataInput.ButtonEventArgs) Handles btnImport.Click
      Dim intSWeekNumber As Integer
      Dim intSWeekYear As Integer
      Dim strSourceFileName As String
      Dim strFullpathSource As String
      Dim strFullpathTarget As String
      Dim selectedWeek As String

      Dim blnFault As Boolean
      blnFault = False

      'Get the actual Path
      strAppPath = HttpContext.Current.ApplicationInstance.Server.MapPath("~/App_Data/")

      selectedWeek = DDimportWeek.SelectedValue()

      intSWeekNumber = Int(Left(selectedWeek, 2))
      intSWeekYear = Int(Right(selectedWeek, 4))

      'Filename of the source file
      strSourceFileName = "DiMSeditionsWeek" & CStr(intSWeekNumber) & "_" & CStr(intSWeekYear) & ".xml"

      'Filename of the target file
      strFileName = "DiMSeditionsWeek" & CStr(intThisWeek) & "_" & CStr(intThisYear) & ".xml"

      strFullpathSource = strAppPath & strSourceFileName
      strFullpathTarget = strAppPath & strFileName

      If File.Exists(strFullpathSource) And isValidfile(strAppPath, strSourceFileName) Then
         Try
            FileCopy(strFullpathSource, strFullpathTarget)
         Catch ex As Exception
            blnFault = True
         End Try

         If (blnFault = False) Then
            Session("strDataPath") = strAppPath
            Session("strFile") = strFileName
         Else
            Session("strDataPath") = Nothing
            Session("strFile") = Nothing
         End If

         resetDates()
         Me.Wdg1.Rows.Clear()
         Me.Wdg1.DataBind()
      End If
   End Sub

   Protected Sub DDimportWeek_SelectionChanged(ByVal sender As Object, ByVal e As Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs) Handles DDimportWeek.SelectionChanged
      'if this is not done, wrong values are given eg. with DDimportWeek.SelectedValue       
      'get the index of the new selection
      Dim idx = e.NewSelection
      'clear selection first
      Me.DDimportWeek.ClearSelection()
      'set the control
      Me.DDimportWeek.SelectedItemIndex() = (idx)
   End Sub

   Protected Sub DDthisWeek_SelectionChanged(ByVal sender As Object, ByVal e As Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs) Handles DDthisWeek.SelectionChanged
      'get the index of the new selection
      Dim idx = e.NewSelection
      'set the control
      Me.DDthisWeek.SelectedItemIndex() = (idx)
      'get the value for the new selection
      Dim val = DDthisWeek.Items(idx).Value
      Session("thisWeek") = val
      intThisWeek = CInt(Session("thisWeek"))
      'Filename
      strFileName = "DiMSeditionsWeek" & CStr(intThisWeek) & "_" & CStr(intThisYear) & ".xml"
      'Get the actual Path
      strAppPath = HttpContext.Current.ApplicationInstance.Server.MapPath("~/App_Data/")

      strFullpath = strAppPath & strFileName

      If File.Exists(strFullpath) Then
         If isValidfile(strAppPath, strFileName) Then
            Session("strDataPath") = strAppPath
            Session("strFile") = strFileName
         Else
            Session("strDataPath") = Nothing
            Session("strFile") = Nothing

         End If
      Else
         Session("strDataPath") = Nothing
         Session("strFile") = Nothing
      End If
      Me.Wdg1.Rows.Clear()
      Me.Wdg1.DataBind()
      'Clear row selections
      Me.Wdg1.Behaviors.Selection.SelectedRows.Clear()
      'Select the first row
      Me.Wdg1.Behaviors.Selection.SelectedRows.Add(Me.Wdg1.Rows(0))
      'Scroll the grid
      Me.Wdg1.ScrollTop = 1
   End Sub

   Protected Sub DDthisYear_SelectionChanged(ByVal sender As Object, ByVal e As Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs) Handles DDthisYear.SelectionChanged
      'get the index of the new selection
      Dim idx = e.NewSelection
      'set the control
      Me.DDthisYear.SelectedItemIndex() = (idx)
      'get the value for the new selection
      Dim val = DDthisYear.Items(idx).Value
      Session("thisYear") = val
      intThisYear = CInt(Session("thisYear"))
      'Filename
      strFileName = "DiMSeditionsWeek" & CStr(intThisWeek) & "_" & CStr(intThisYear) & ".xml"
      'Get the actual Path
      strAppPath = HttpContext.Current.ApplicationInstance.Server.MapPath("~/App_Data/")

      strFullpath = strAppPath & strFileName

      If File.Exists(strFullpath) Then
         If isValidfile(strAppPath, strFileName) Then
            Session("strDataPath") = strAppPath
            Session("strFile") = strFileName
         Else
            Session("strDataPath") = Nothing
            Session("strFile") = Nothing

         End If
      Else
         Session("strDataPath") = Nothing
         Session("strFile") = Nothing
      End If
      Me.Wdg1.Rows.Clear()
      Me.Wdg1.DataBind()
      'Clear row selections
      Me.Wdg1.Behaviors.Selection.SelectedRows.Clear()
      'Select the first row
      Me.Wdg1.Behaviors.Selection.SelectedRows.Add(Me.Wdg1.Rows(0))
      'Scroll the grid
      Me.Wdg1.ScrollTop = 1
   End Sub

   Private Function isValidfile(ByVal strAppPath As String, ByVal strFilename As String) As Boolean
      'check the file wheter it is a valid xml file
      Dim baseuri As Uri
      Dim fulluri As Uri
      Dim reader As XmlReader
      Dim resolver As XmlUrlResolver
      Dim rStream As Stream
      Dim strFullpath As String
      Dim xmlDoc As XmlDocument

      Dim flgError As Boolean

      Try
         'Create an XmlUrlResolver with default credentials.
         resolver = New XmlUrlResolver()
         resolver.Credentials = System.Net.CredentialCache.DefaultCredentials

         strFullpath = strAppPath & strFilename

         'Point the resolver at the desired resource and resolve as a stream.
         baseuri = New Uri(strFullpath)

         ' Create the reader with the resolved stream and display the data.
         fulluri = resolver.ResolveUri(baseuri, strFilename)
         rStream = Nothing
         Try
            rStream = DirectCast(resolver.GetEntity(fulluri, Nothing, GetType(Stream)), Stream)
         Catch ex As Exception
            flgError = True
         End Try

         If Not flgError Then
            xmlDoc = New XmlDocument()
            reader = XmlReader.Create(rStream)
            Try
               xmlDoc.Load(reader)
            Catch ex As Exception
               flgError = True
            Finally
               reader.Close()
               rStream.Close()
            End Try
         End If

      Catch ex As Exception
         flgError = True
      End Try

      If (flgError = True) Then
         'Me.lblStatus.Text = "Can not read the data file " & strFilename & "! Please check the file!"
         Me.lblStatus.Text = "Die Datei '" & strFilename & "' kann nicht gelesen werden! Bitte pr&uuml;fen Sie die Datei!"
         Me.lblStatus.ForeColor = Drawing.Color.Red
         Me.lblStatus.Visible = True
         Return False
      Else
         Me.lblStatus.Visible = False
         Return True
      End If

   End Function

   Protected Sub Page_PreLoad(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.PreLoad
      intThisYear = CInt(Session("thisYear"))
      'get the actual week
      intThisWeek = CInt(Session("thisWeek"))
      If (intThisWeek = 0) Then
         intThisWeek = DatePart(DateInterval.WeekOfYear, DateTime.Now, vbMonday, vbFirstFourDays)
         intThisYear = DatePart(DateInterval.Year, DateTime.Now)
         Session("thisWeek") = intThisWeek
         Session("thisYear") = intThisYear
         Me.thisWeek.Value = intThisWeek
         Me.thisYear.Value = intThisYear
      End If
      If (Not IsPostBack) Then
         '!!Index can be zero and that is is week1
         Me.DDthisWeek.SelectedItemIndex() = (intThisWeek - 1)
         Me.DDimportWeek.SelectedItemIndex = 0
         Me.DDthisYear.SelectedItemIndex = (intThisYear - 2010) 'the dropdowns starts with 2010
      End If
      'Filename
      strFileName = "DiMSeditionsWeek" & CStr(intThisWeek) & "_" & CStr(intThisYear) & ".xml"
      'Get the actual Path
      strAppPath = HttpContext.Current.ApplicationInstance.Server.MapPath("~/App_Data/")
      Session("strDataPath") = strAppPath
      strFullpath = strAppPath & strFileName

      If File.Exists(strFullpath) Then
         If isValidfile(strAppPath, strFileName) Then
            Session("strFile") = strFileName
         Else
            Session("strFile") = Nothing
         End If
      Else
         Session("strFile") = Nothing
      End If
   End Sub

   Protected Sub resetDates()
      Dim baseUri As Uri
      Dim element As XmlElement = Nothing
      Dim flgError As Boolean
      Dim fulluri As Uri

      Dim rStream As Stream
      Dim reader As XmlReader
      Dim resolver As XmlUrlResolver
      Dim strCompletePath As String
      Dim strFilename As String
      Dim strFullPath As String
      Dim strNewDate As String

      Dim subelement As XmlElement = Nothing
      'Dim writer As XmlWriter
      Dim xmlDoc As XmlDocument

      flgError = False
      'get the filename from a session var

      strFullPath = Session("strDataPath")
      strFilename = Session("strFile")

      If strFilename Is Nothing Then
         Exit Sub
      End If

      xmlDoc = Nothing

      'Point the resolver at the desired resource and resolve as a stream.
      baseUri = New Uri(strFullPath)

      strCompletePath = strFullPath & strFilename

      'Create an XmlUrlResolver with default credentials.
      resolver = New XmlUrlResolver()
      resolver.Credentials = System.Net.CredentialCache.DefaultCredentials

      ' Create the reader with the resolved stream and display the data.
      fulluri = resolver.ResolveUri(baseUri, strFilename)
      rStream = Nothing
      Try
         rStream = DirectCast(resolver.GetEntity(fulluri, Nothing, GetType(Stream)), Stream)
      Catch ex As Exception
         flgError = True
      End Try

      If Not flgError Then
         xmlDoc = New XmlDocument()
         reader = XmlReader.Create(rStream)
         Try
            xmlDoc.Load(reader)
            reader.Close()
            rStream.Close()
         Catch ex As Exception
            'we do not throw an exception at this point. The file was checked before
            'so give only an empty obj.
            xmlDoc = Nothing
         End Try
      End If
      'Ok here we are, now calculate the new value for the new date that we want to write
      strNewDate = setnewDate()

      If Not IsNothing(xmlDoc) Then
         For Each element In xmlDoc.DocumentElement
            If element.HasChildNodes Then
               For i = 0 To element.ChildNodes.Count - 1
                  subelement = element.ChildNodes(i)
                  subelement.SetAttribute("deliveryDateTime", strNewDate)
               Next (i)
            End If
         Next
      End If
      xmlDoc.Save(strCompletePath)
   End Sub

   Private Function setnewDate() As String
      Dim lastWeek As Integer
      Dim thisWeek = Convert.ToInt16(Session("thisWeek"))
      Dim thisYear = Convert.ToInt16(Session("thisYear"))
      Dim strTime As String
      Dim strTmp As String
      Dim strThursday As String

      lastWeek = thisWeek - 1
      strThursday = calcThursday(lastWeek, thisYear)
      strTime = "T12:00+02:00"

      strTmp = strThursday.Substring(0, 10) + strTime

      Return strTmp
   End Function

   '
   'return the thursday of a given week
   Function calcThursday(ByVal intWeek As Integer, ByVal intYear As Integer) As String
      Dim dat As Date
      Dim retValue As String
      dat = CalendarWeek(intWeek, intYear)
      dat = dat.AddDays(+3)

      retValue = dat.ToString("O")
      Return retValue
   End Function

   Public Function CalendarWeek(ByVal nWeek As Integer, ByVal nYear As Integer) As Date

      ' Wochentag des 4. Januar des Jahres ermitteln
      Dim dStart As New Date(nYear, 1, 4)
      Dim nDay As Integer = (dStart.DayOfWeek + 6) Mod 7 + 1

      ' Beginn der 1. KW des Jahres
      Dim dFirst As Date = dStart.AddDays(1 - nDay)

      ' Gesuchte KW ermitteln
      Return dFirst.AddDays((nWeek - 1) * 7)
   End Function
End Class
